!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.-N. Lang                             |            !
!        | `---' | UFO date: 04/2020                              |            !
!        |       | UFO version: 0.9                               |            !
!        |       | Generation date: 2020-03-10 10:59             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 20

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(61)
  integer, parameter :: nGC_17 = 1
  integer, parameter :: nGC_16 = 2
  integer, parameter :: nGC_15 = 3
  integer, parameter :: nGC_14 = 4
  integer, parameter :: nGC_13 = 5
  integer, parameter :: nGC_12 = 6
  integer, parameter :: nGC_11 = 7
  integer, parameter :: nGC_10 = 8
  integer, parameter :: nGC_604 = 9
  integer, parameter :: nGC_610 = 10
  integer, parameter :: nGC_3 = 11
  integer, parameter :: nGC_2 = 12
  integer, parameter :: nGC_1 = 13
  integer, parameter :: nGC_7 = 14
  integer, parameter :: nGC_6 = 15
  integer, parameter :: nGC_5 = 16
  integer, parameter :: nGC_4 = 17
  integer, parameter :: nGC_608 = 18
  integer, parameter :: nGC_9 = 19
  integer, parameter :: nGC_8 = 20
  integer, parameter :: nGC_134 = 21
  integer, parameter :: nGC_194 = 22
  integer, parameter :: nGC_1405 = 23
  integer, parameter :: nGC_1404 = 24
  integer, parameter :: nGC_1431 = 25
  integer, parameter :: nGC_546 = 26
  integer, parameter :: nGC_1419 = 27
  integer, parameter :: nGC_38 = 28
  integer, parameter :: nGC_1430 = 29
  integer, parameter :: nGC_56 = 30
  integer, parameter :: nGC_1418 = 31
  integer, parameter :: nGC_1433 = 32
  integer, parameter :: nGC_1417 = 33
  integer, parameter :: nGC_1414 = 34
  integer, parameter :: nGC_1413 = 35
  integer, parameter :: nGC_330 = 36
  integer, parameter :: nGC_120 = 37
  integer, parameter :: nGC_1406 = 38
  integer, parameter :: nGC_1427 = 39
  integer, parameter :: nGC_1426 = 40
  integer, parameter :: nGC_1423 = 41
  integer, parameter :: nGC_1422 = 42
  integer, parameter :: nGC_1421 = 43
  integer, parameter :: nGC_1420 = 44
  integer, parameter :: nGC_1409 = 45
  integer, parameter :: nGC_1408 = 46
  integer, parameter :: nGC_26 = 47
  integer, parameter :: nGC_1429 = 48
  integer, parameter :: nGC_280 = 49
  integer, parameter :: nGC_1407 = 50
  integer, parameter :: nGC_1428 = 51
  integer, parameter :: nGC_1434 = 52
  integer, parameter :: nGC_1425 = 53
  integer, parameter :: nGC_1424 = 54
  integer, parameter :: nGC_1432 = 55
  integer, parameter :: nGC_1416 = 56
  integer, parameter :: nGC_1415 = 57
  integer, parameter :: nGC_1412 = 58
  integer, parameter :: nGC_1410 = 59
  integer, parameter :: nGC_1411 = 60
  integer, parameter :: nGC_2119 = 61
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
